• CATIA插件二次开发C#

    2018/6/22??????点击:

    1. 引言

    兴业彩票 www.bluexu.com 由于项目中要使用WISEGLOVE数据手套,最近搜集整理了一些关于CATIA二次开发的资料,网络的相关资料比较有限,因此刚开始遇到了不少问题,通过分析一些示例,以及结合CATIA的宏录制功能生成的代码,才算是对CATIA的开发方式有所了解。现总结一下学习中遇到的相关问题及解决办法,以共享各位小朋友。

    2. CATIA简介

    CATIA(Computer Aided Three Dimensional Interactive Application)是法国达索公司的产品开发旗舰解决方案。作为PLM协同解决方案的一个重要组成部分,它可以帮助制造厂商设计他们未来的产品,并支持从项目前阶段、具体的设计、分析、模拟、组装到维护在内的全部工业设计流程。通过使企业能够重用产品设计知识,缩短开发周期,CATIA解决方案加快企业对市场的需求的反应。CATIA比较广泛的用于汽车、航空航天、轮船、军工、仪器仪表、建筑工程、电气管道、通信等方方面面(来源-百度百科-CATIA)。

    3. CATIA开发模式

    CATIA提供了AutomationAPI组件和组件应用架构(CAA,Component Application Architecture)两种开发模式。

    3.1 Automation组件

    Automation API具备与任何OLE所兼容的平台进行通讯能力,自动化(Automation)组件使用VBScript作为编辑工具。通过宏录制功能(Macro Record),可以记录用户的操作过程并自动生成VBScript代码。这种方式比较简单,在CATIA环境就中可完成。

    3.2 组件应用架构(CAA)

    CAA采用组件对象模型(COM)和对象的连接和嵌入(OLE)技术,COM作为一种软件架构具备了更好的模块独立性、可扩展性,使CAA的程序设计更加容易且趋于标准化,使程序的代码更加简洁明了。在CATIA运行的情况下,外部进程可以通过访问COM组件实现对CATIA的操作,如创建、修改CATIA环境和几何形体的数据、尺寸等。

    4. 为什么采用C#作为开发语言

    VBScript脚本方法过于简单,无法实现CATIA的某些功能,如碰撞检测功能,且无法与现有项目进行集成。CAA/C++模式是最复杂的开发模式,其可以实现几乎所有的CATIA功能,但是其过于复杂,需要一定的学习时间,无法很快进行功能实现。因此这两种实现方式都不是很适合。由于CATIA提供了COM支持,因此我们可以通过.Net平台引入COM组件进行开发,其有如下优势: 
    1. 由于项目本身采用的是CSharp语言,因此能够很好的集成到项目中,并且能够满足项目需求。 
    2. 学习成本较低,通过对宏生成代码进行少许改造即可在.Net平台中运行。 
    3. 可以将通用操作进行封装,方便今后项目的开发,降低开发成本。

    5. 准备开发

    5.1 所需软件

    • CATIA V5 R20
    • Visual Studio 2010

    5.2 引入类库

    在正确安装CATIA之后即可在项目中引用CATIA COM类库,其类库名称均以CATIA V5开头。在引用为类库后,我们即可进行开发工作。 


    5.3 开发示例

    该示例演示了如何连接CATIA,并生成一个新的Product。

    namespace CATIATest
    {
        class Program
        {
            static void Main(string[] args)
            {
                // 连接CATIA
                Application Catia =(Application)System.Runtime.InteropServices.Marshal.GetActiveObject("Catia.Application");
                // 获取当前活动ProductDocument
                ProductDocument pd = (ProductDocument)Catia.ActiveDocument;
                // 创建一个ID为newProduct的Product
                pd.Product.Products.AddNewProduct("newProduct");
            }
        }
    }

    【注意】在调试之前请确保CATIA已经运行,否则无法连接到CATIA,程序无法运行。

    6. 开发中使用到的操作总结

    6.1 加载CATIA文件

    public void AddNewComponent(string filePath)
    {
        object[] files = new object[1] { filePath };
        this.ActiveProductDocument.Product.Products.AddComponentsFromFiles(files, "All");
    }

    6.2 向当前Product中添加Part

    // 向当前Product中添加一个指定长度的圆柱体
    public void CreateCylinder(string name, double length)
    {
        // 添加一个新零件
        Product product = this.ActiveProductDocument.Product.Products.AddNewComponent("Part", name);
        // 绘制圆
        Part part = ((PartDocument)this._catia.Documents.Item(name + ".CATPart")).Part;
        Sketch sketch = (part.Bodies.GetItem("零件几何体") as Body).Sketches.Add(
            (Reference)part.OriginElements.PlaneXY);
        sketch.SetAbsoluteAxisData(new object[] { 0, 0, 0, 1, 0, 0, 0, 1, 0 });
        part.InWorkObject = sketch;
        Factory2D factory = sketch.OpenEdition();
        Axis2D axis = (Axis2D)sketch.GeometricElements.GetItem("绝对轴");
        (axis.GetItem("横向") as Line2D).ReportName = 1;
        (axis.GetItem("纵向") as Line2D).ReportName = 2;
        Circle2D circle = factory.CreateClosedCircle(0, 0, 5);
        circle.CenterPoint = (Point2D)axis.GetItem("原点");
        circle.ReportName = 3;
        sketch.CloseEdition();
        part.Update();
        // 绘制圆柱
        (part.ShapeFactory as ShapeFactory).AddNewPad(sketch, length);
        part.Update();
    }

    6.3 查找Product

    // 根据产品名称获取指定Product
    public Product GetProduct(string productId)
    {
        return (Product)this.ActiveProductDocument.Product.Products.GetItem(productId);
    }

    6.4 移除Product

    protected void RemoveProduct(Product product)
    {
        Selection selection = this.ActiveProductDocument.Selection;
        selection.Clear();
        selection.Add(product);
        selection.Delete();
    }

    6.5 碰撞检测

    // 检测两个产品间是否存在冲突
    public bool ConflictCheck(Product product1, Product product2)
    {
        Groups groups = this.ActiveProductDocument.Product.GetTechnologicalObject("Groups") as Groups;
        Group first = groups.Add();
        Group second = groups.Add();
        first.AddExplicit(product1);
        second.AddExplicit(product2);
        Clash clash = (this.ActiveProductDocument.Product.GetTechnologicalObject("Clashes") as Clashes).Add();
        clash.ComputationType = CatClashComputationType.catClashComputationTypeBetweenTwo;
        clash.InterferenceType = CatClashInterferenceType.catClashInterferenceTypeContact;
        clash.FirstGroup = first;
        clash.SecondGroup = second;
        clash.Compute();
        Conflicts conflicts = clash.Conflicts;
        groups.Remove(first.get_Name());
        groups.Remove(second.get_Name());
        return conflicts.Count != 0;
    }

    6.6 自动调整视图

    protected void AdapteAllView()
    {
        this._catia.ActiveWindow.ActiveViewer.Reframe();
    }

    7. 其他功能探索

    一般来说,对于CATIA中能够手工解决的问题均应能够通过编程的方式处理,我们可以通过以下三种途径获取编程帮助以及Sample。

    1. V5 Automation API 手册(推荐)
    2. CATIA 宏录制功能
    3. Baidu 以及 Google

    方式一:在安装好CATIA后,再其安装目录中%Install Root%\Dassault Systemes\B20\intel_a\code\bin中已经包含了V5 Automation API .chm帮助文档。该文档中包含了全部的可用API及类继承结构,同时提供了丰富的代码示例供读者参考。 

    CATIA

    方式二:通过启用CATIA的宏录制功能,可以获得所有操作的VBScript代码,我们可以参考该代码进行CSharp代码的开发。下图通过CATIA录制了一个绘制圆柱的过程,右侧窗口内显示的即为生成的VBScript代码。 

    CATIA


    8. WISEGLOVE数据手套在CATIA中使用

    按照上面的方法, 各位小朋友应该能和我们一样实现WISEGLOVE数据手套在CATIA中的应用。